searchData={"items":[{"type":"behaviour","title":"RateLimiterMan","doc":"A rate limiter implementation, based heavily on a blog post by [Alex\nKoutmous](https://akoutmos.com/post/rate-limiting-with-genservers/).\n\nThis package handles logic for limiting the rate at which HTTP requests are sent.\n\n> #### TODO {: .warning}\n>\n> Add more documentation.","ref":"RateLimiterMan.html"},{"type":"function","title":"RateLimiterMan.calculate_refresh_rate/1","doc":"","ref":"RateLimiterMan.html#calculate_refresh_rate/1"},{"type":"function","title":"RateLimiterMan.get_max_requests_per_second/1","doc":"","ref":"RateLimiterMan.html#get_max_requests_per_second/1"},{"type":"function","title":"RateLimiterMan.get_rate_limiter/1","doc":"","ref":"RateLimiterMan.html#get_rate_limiter/1"},{"type":"function","title":"RateLimiterMan.make_request/4","doc":"","ref":"RateLimiterMan.html#make_request/4"},{"type":"callback","title":"RateLimiterMan.make_request/4","doc":"","ref":"RateLimiterMan.html#c:make_request/4"},{"type":"type","title":"RateLimiterMan.response_handler/0","doc":"","ref":"RateLimiterMan.html#t:response_handler/0"},{"type":"function","title":"RateLimiterMan.skip_response_handler/1","doc":"","ref":"RateLimiterMan.html#skip_response_handler/1"},{"type":"module","title":"RateLimiterMan.LeakyBucket","doc":"A leaky-bucket rate limiter that processes requests at a fixed rate (e.g. 1 request per second).\n\n> #### TODO {: .warning}\n>\n> Add more documentation.","ref":"RateLimiterMan.LeakyBucket.html"},{"type":"function","title":"RateLimiterMan.LeakyBucket.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"RateLimiterMan.LeakyBucket.html#child_spec/1"},{"type":"function","title":"RateLimiterMan.LeakyBucket.make_request/4","doc":"Call a function using the rate limiter.","ref":"RateLimiterMan.LeakyBucket.html#make_request/4"},{"type":"function","title":"Receiving a response - RateLimiterMan.LeakyBucket.make_request/4","doc":"To receive a response from the rate limiter, you must pass in the following `opts`:\n\n  - `from` - The PID of the process that will receive the response (e.g. `self()`)\n  - `request_id` - A unique identifier (e.g. a random number, or the `x-request-id` header)\n\nThen, add a receive block where you want the response to be received:\n\n    iex> receive do\n    ...>   {:ok, %{request_id: request_id, resp: resp}} when request_id == your_request_id ->\n    ...>     resp\n    ...> after\n    ...>   30_000 -> {:error, :gateway_timeout}\n    ...> end","ref":"RateLimiterMan.LeakyBucket.html#make_request/4-receiving-a-response"},{"type":"function","title":"Examples - RateLimiterMan.LeakyBucket.make_request/4","doc":"Get a reference to the desired rate limiter for the following examples:\n\n    iex> rate_limiter = RateLimiterMan.get_rate_limiter(YourProject.RateLimiter)\n\nMake a request using the rate limiter:\n\n    iex> rate_limiter.make_request(\n    ...>   _api_provider = YourProject.RateLimiter,\n    ...>   _request_handler = {IO, :puts, [\"Hello world!\"]}\n    ...> )\n    :ok\n\nOr, make a request using the rate limiter, and have the rate limiter send the response back to\nthe caller via message passing:\n\n    # Generate a unique request ID\n    iex> request_id = System.unique_integer()\n\n    # Make the request\n    iex> rate_limiter.make_request(\n    ...>   _api_provider = YourProject.RateLimiter,\n    ...>   _request_handler = {String, :duplicate, [\"Hello world! \", 2]},\n    ...>   _response_handler = nil,\n    ...>   from: self(),\n    ...>   request_id: unique_request_id\n    ...> )\n    :ok\n\n    # Receive the response for further processing\n    iex> receive do\n    ...>   {:ok, %{request_id: request_id, resp: resp}} when request_id == unique_request_id ->\n    ...>     resp\n    ...> after\n    ...>   30_000 -> {:error, :gateway_timeout}\n    ...> end\n    \"Hello world! Hello world! \"","ref":"RateLimiterMan.LeakyBucket.html#make_request/4-examples"},{"type":"function","title":"RateLimiterMan.LeakyBucket.skip_response_handler/1","doc":"","ref":"RateLimiterMan.LeakyBucket.html#skip_response_handler/1"},{"type":"function","title":"RateLimiterMan.LeakyBucket.start_link/1","doc":"","ref":"RateLimiterMan.LeakyBucket.html#start_link/1"},{"type":"extras","title":"RateLimiterMan","doc":"# RateLimiterMan\n\nA simple rate limiter implementation, adapted from [a blog post by Alex Koutmous](https://akoutmos.com/post/rate-limiting-with-genservers/).\n\n> #### Warning\n>\n> This is a very early release. It works but has some rough edges, and shouldn't be considered\n> production-ready for most use cases.","ref":"readme.html"},{"type":"extras","title":"Getting started - RateLimiterMan","doc":"","ref":"readme.html#getting-started"},{"type":"extras","title":"Installation - RateLimiterMan","doc":"Add this package to your list of dependencies in `mix.exs`, then run `mix deps.get`:\n\n```elixir\n{:rate_limiter_man, \"0.1.0\"}\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - RateLimiterMan","doc":"Basic usage instructions coming soon. For now, see [the blog post by Alex Koutmous](https://akoutmos.com/post/rate-limiting-with-genservers/).\n\nThis project also has a mechanism for the rate limiter to pass its responses back to the caller. See `RateLimiterMan.make_request/4` for more information.\n\nFor more information, see [the project documentation](https://hexdocs.pm/rate_limiter_man).","ref":"readme.html#usage"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}